function Rank = PermRankEst(X,alpha,Nperm)
%Rank = PermRankEst(X,alpha,nperm)
%Determines underlying rank of a noisy matrix X, for significance level
%alpha and Nperm permutations.

[m,n] = size(X);
[U,S,V] = svds(X,min(m,n));
Count = zeros(min(m,n),1);
for(i=1:Nperm)
    Xperm = X;
    for(j=1:m)
        Xperm(j,:) = X(j,randperm(n));
    end
    [Uperm,Sperm,Vperm] = svds(Xperm,min(m,n));
    blah = diag(Sperm)>diag(S);
    Count = Count+blah;
end   
P = (Count+1)/(Nperm+1);
Rank = min(n,m);
for(i=1:min(n,m))
    if(P(i)>alpha) Rank = i-1; break;
    end
end

return;
    